////////////////////////////////////////////////////////////////////////////////
//
//		Title		: NScrollBarWnd.h File
//
//		Copyright (C) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
//
//		Team		: Desktop Service Development
//
//		author		: hhd2002
//
//		created		: 21:12:2006   21:51
//  
//////////////////////////////////////////////////////////////////////////////// 
#pragma once

#include "NPCommonUI.h"
#include "NScrollBar.h"
#include "BaseWindow.h"

/**
 * \group CommonUI
 * \brief {kr} NScrollBar ctrl ũѹ  {/kr}
 * \date 2007-01-15
 * \author hhd2002
 * \remark {kr} window handle  parent window  Ѵ. {/kr}
 */
class NPCOMMONUI_API CNScrollBarWnd : public IScrollListener
{
public:
	/**
	 * \brief 	{kr} Ctrl ũѹ  {/kr}
	 * \param hWnd {kr} parent window ڵ {/kr}
	 * \param pNSBUI {kr} ũѹ UI {/kr}
	 * \param dwStyle {kr} ũѹ Ÿ {/kr}
	 * \param nButtonWidth {kr} ũѹ ư  {/kr}
	 * \param nThumbWidth {kr} ũѹ   {/kr}
	 * \param nHandleWidth {kr} ũѹ ڵ  {/kr}
	 * \param pScrollBarCustomize {kr} ũѹ customize set {/kr}
	 */
	CNScrollBarWnd(	HWND hWnd, 
					IScrollBarUI* pNSBUI, 
					DWORD dwStyle = CNScrollBar::NSBS_HSCROLL, 
					int nButtonWidth = 0, 
					int nThumbWidth = 0,
					int nHandleWidth = 0, 
					IScrollBarCustomize* pScrollBarCustomize = NULL	);
	
	virtual ~CNScrollBarWnd();

	/**
	 * \brief 	{kr} ctrl ũѹٸ  RECT ű. {/kr}
	 */
	BOOL MoveWindow(PRECT pRect, BOOL bRedraw = FALSE);

	/**
	* \brief				{kr} SCROLLINFO ´. {/kr}
	* \param lpScrollInfo	{kr} [out] SCROLLINFO  {/kr}
	*/
	BOOL	GetScrollInfo(LPSCROLLINFO lpScrollInfo, UINT nMask = SIF_ALL);

	/**
	* \brief				{kr} ũ ִ  Ѵ. {/kr}
	* \return				{kr}  : ũ ִ  .  : 0 . {/kr}
	*/
	int		GetScrollLimit();

	/**
	* \brief				{kr} ũ ڽ  ġ Ѵ. {/kr}
	* \remark 				{kr}  ũ ڽ ġ  ̴.   100~200  150 ̴߰. {/kr}
	* \return				{kr}  : ũ ڽ  ġ .  : 0 . {/kr}
	*/
	int		GetScrollPos( );

	/**
	* \brief				{kr} ũѹ   ´. {/kr}
	* \remark 				{kr} Ʈ Ѵ 0. {/kr}
	* \param lpMinPos		{kr} ּҰ  {/kr}
	* \param lpMaxPos		{kr} ִ밪  {/kr}
	*/
	void	GetScrollRange(LPINT lpMinPos, LPINT lpMaxPos);

	/**
	* \brief				{kr} SCROLLINFO Ѵ. {/kr}
	* \remark 				{kr}  {/kr}
	* \param lpScrollInfo	{kr} [in] SCROLLINFO . {/kr}
	* \param bRedraw		{kr} [in]	TRUE :   ݿϿ ũѹٸ ٽ ׷ش.
		FALSE : ٽ ׸ ʴ´.
	{/kr}
	* \return				{kr}  : TRUE . {/kr}
	*/
	int		SetScrollInfo(LPSCROLLINFO lpScrollInfo, BOOL bRedraw = TRUE);

	/**
	* \brief				{kr}  ũ ڽ ġ nPos ϰ bRedraw Ǵؼ ٽ ׸. {/kr}
	* \remark 				{kr}  {/kr}
	* \param nPos			{kr} [in] ũ ڽ  ġ.   ũ  ̳ ̾ Ѵ. {/kr}
	* \param bRedraw		{kr} [in] TRUE :  ġ  ũѹٸ  ׸. {/kr}
	* \return				{kr} bRedraw FALSE   ªð ؼ ٸ  
		SetScrollPos ȣ  Ѵ. {/kr}
	*/
	int		SetScrollPos(int nPos, BOOL bRedraw = TRUE);

	/**
	* \brief				{kr} ũѹ ּ, ִ  Ѵ. {/kr}
	* \remark 				{kr} nMinPos, nMaxPos 0̸ ũѹٰ Ȱȴ. SetScrollRange ȣĿ ٷ SetScrollRange
		ȣϴ 쿡 SetScrollPos bRedrawn FALSE Ѵ  2 ٽ ׸  ´.
		  ִ 32767̴.{/kr}
	* \param nMinPos		{kr} [in] ּ . {/kr}
	* \param nMaxPos		{kr} [in] ִ . {/kr}
	* \param bRedraw		{kr} [in]	TRUE :   ݿϿ ũѹٸ ٽ ׷ش.
	FALSE : ٽ ׸ ʴ´. {/kr}
	*/
	void	SetScrollRange(int nMinPos, int nMaxPos, BOOL bRedraw = TRUE);

	/**
	* \brief				{kr} ũѹٸ /. {/kr}
	* \remark 				{kr} APP ũѹ ޽ ް  ɼ  Լ ȣϸ ȵȴ. {/kr}
	* \param bShow			{kr} TRUE : ũѹٸ . {/kr}
	*/
	void	ShowScrollBar(BOOL bShow = TRUE);

	/**
	* \brief	{kr} ڵɼ ԷѴ. {/kr}
	* \param dwMinTime {kr} ڵ齺ũѽ ũ notify ޽ ּ hop ð. {/kr}
	* \param nHandleHop {kr} ڵ齺ũѽ ũ notify ޽ hop width. {/kr}
	*/
	void	SetHandleOption(DWORD dwMinTime = 10, int nHandleHop = 1, int nTimeMultiplyNum = 10, int nHopMultiplyNum = 10);

	/**
	* \brief	{kr} ڵɼ ´. {/kr}
	* \param pdwMinTime {kr} [out] ڵ齺ũѽ ũ notify ޽ ּ hop ð. {/kr}
	* \param pnHandleHop {kr} [out] ڵ齺ũѽ ũ notify ޽ hop width. {/kr}
	*/
	void	GetHandleOption(DWORD* pdwMinTime, int* pnHandleHop);

	/**
	* \brief	{kr} UIŬ . {/kr}
	* \param pComponentUI {kr} UIŬ {/kr}
	*/
	virtual void	SetUI(IComponentUI* pComponentUI);

	/**
	* \brief	{kr} Ÿ . {/kr}
	* \param dwStyle {kr} NSB_HSCROLL, ... {/kr}
	*/
	void	ModifyStyle(DWORD dwStyle);

	/**
	* \brief 	{kr} ũѹ  disable/enable   {/kr}
	* \param bEnable {kr} TRUE̸ enable FALSE̸ disable {/kr}
	*/
	void	Enable(BOOL bEnable = TRUE);

	/**
	 * \brief 	{kr} ũѹٰ ̴? {/kr}
	 * \return 
	 */
	BOOL IsVisible();

	/**
	 * \brief 	{kr} ũѹٰ Ȱ? {/kr}
	 * \return 
	 */
	BOOL IsEnable();

	/**
	* \brief 	{kr} ڵ Ʈ Ѵ, 
				-1(ڵ shaft / ) ~ 0(ڵ shaft ߾) ~ 1(ڵ shaft Ʒ/ ) {/kr}
	*/
	float GetHandleMoment()
	{
		return m_pNSB->GetHandleMoment();
	}

	/**
	 * \brief 	{kr} ũѹٰ Hũ ڵ鷯 {/kr}
	 * \param pScrollEvent {kr}  {/kr}
	 */
	virtual void	OnHScroll(CScrollEvent* pScrollEvent = NULL);
	virtual void	OnVScroll(CScrollEvent* pScrollEvent = NULL);

	/**
	 * \brief 	{kr}  {/kr}
	 * \param hWnd 
	 * \param uMsg 
	 * \param wParam 
	 * \param lParam 
	 * \param lResult 
	 * \param dwMsgMapID 
	 * \return 
	 */
	BOOL ProcessWindowMessage(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT& lResult, DWORD dwMsgMapID = 0)
	{
		return m_pNSB->ProcessWindowMessage(hWnd, uMsg, wParam, lParam, lResult, dwMsgMapID);
	}

protected:
private:
	CNScrollBar* m_pNSB; ///< {kr} ũѹ ü {/kr}
	CBaseWindow* m_pBaseWnd; ///< {kr} ũѹٿ win32   owner. {/kr}
	HWND m_hWndOwner; ///< {kr}  ũѹٸ  . {/kr}
	CRect m_rcBound;
};